#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

//
//
//
//
//

extern int    Length   = 50;
extern int    Price    = PRICE_CLOSE;
extern int    MaLength = 20;
extern int    MaMethod = MODE_SMA;
extern int    MaxBars  = 250;
extern string UniqueID = "boxes";
extern color  BoxColor = DarkGray;
extern int    BoxWidth = 0;
extern bool   BoxBack  = false;

double sd[];
double ma[];
double state[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,sd);
   SetIndexBuffer(1,ma);
   SetIndexBuffer(2,state);

   return(0);
}
int deinit()
{
   int lookForLength = StringLen(UniqueID);
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == UniqueID) ObjectDelete(name);
      }
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars+MaxBars,Bars-1);
         if (state[limit]!=0) for (; limit<Bars-1; limit++) if (state[limit]==0) break;
         
         //
         //
         //
         //
         //
         
   for(i=limit; i>=0; i--) sd[i] = iStdDev(NULL,0,Length,0,MODE_SMA,Price,i);
   for(i=limit; i>=0; i--)
   {
      ma[i] = iMAOnArray(sd,0,MaLength,0,MaMethod,i);
      state[i] = state[i+1];
         if (sd[i]>ma[i]) state[i] = state[i+1]+1;
         if (sd[i]<ma[i]) state[i] = 0;

         //
         //
         //
         //
         //
         
         ObjectDelete(UniqueID+":"+Time[i]);
         if (i<MaxBars && ((state[i]==0 && state[i+1]!=0) || (i==0 && state[i]!=0)))
         {
            int k = i+(i!=0);
            int m = k;
            double max = sd[k];
               for( ;state[k]!=0 && k<Bars; k++)
               {
                  if (sd[k]>max)
                  {
                     m=k; max = sd[k];
                  }
               }
               string name = UniqueID+":"+Time[m];
                  ObjectCreate(name,OBJ_RECTANGLE,0,Time[m],High[m],Time[0],Low[m]);
                     ObjectSet(name,OBJPROP_BACK ,BoxBack);
                     ObjectSet(name,OBJPROP_COLOR,BoxColor);
                     ObjectSet(name,OBJPROP_WIDTH,BoxWidth);
         }
   }
   return(0);
}